
Object subclass: #AccountClass
  instanceVariableNames: ''
  classVariableNames: 
    'Money '
  poolDictionaries: '' !


!AccountClass class methods ! !



!AccountClass methods !
   
money
^Money.!
 
money: aInteger
Money:= aInteger.! !

Object subclass: #CompClass
  instanceVariableNames: ''
  classVariableNames: 
    'PowerOn Link '
  poolDictionaries: '' !


!CompClass class methods ! !



!CompClass methods !
 
initialState
self link: false.
self powerOn: false.!
  
link
^Link.!
   
link: aBoolean
Link:=aBoolean.!

linking
  (Comp powerOn)
     ifTrue: [ (Pass enter)
                        ifTrue:[  (self link)
                                        ifTrue:[Internet answer:'    .'.]
                                        ifFalse: [self link: true. Internet answer:'   .'.].
                                  ]
                        ifFalse: [Internet answer:'    .'.]
                ]
     ifFalse: [Internet answer:'  .'.].!
 
powerOn
^PowerOn.!
 
powerOn: aBoolean
PowerOn:=aBoolean.! !

ViewManager subclass: #InternetClass
  instanceVariableNames: 
    'streamOfAnswer textPane '
  classVariableNames: 
    'NotAssign '
  poolDictionaries: '' !


!InternetClass class methods ! !



!InternetClass methods !
 
answer: aString
".         (Transcript),
        "
   (streamOfAnswer isNil
        ifTrue: [Transcript]
        ifFalse: [streamOfAnswer]) nextPutAll: aString;
                                                      cr!
 
createViews
" .      "
     | v |
    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  '  Internet.';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 2200 @ 1000; xC; yC; cRDU: (9 @ 656 rightBottom: 1333 @ 52));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            addSubpane: (
                streamOfAnswer:=TextPane new
                    owner: self;
                    when:#getContents perform:#toPlay:;
                    framingRatio:(0 @ 0 extent: (7/10) @ 1);
                    startGroup;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    contents:(self punkts);
                    when:#doubleClickSelect perform:#punkt:;
                    framingRatio: ((7/10) @ (0/10) extent: (3/10) @ (10/10));
                    startGroup;
                    yourself
            );
        yourself
   ).
   self openWindow.!
  
initialState
"     "

User initialState.
Prov initialState.
Pass initialState.
Comp initialState.!

punkt: aListBox
" .   '    '   "

 (aListBox selectedItem) = ''
    ifTrue: [self quit].

 (aListBox selectedItem) = ''
    ifTrue: [ self answer:''.
                  NotAssign:=false.
                 Prov newGame].
(NotAssign)
ifTrue: [self answer: '   .']
ifFalse:[
 (aListBox selectedItem) = ' '
      ifTrue: [ User compPowerOn.].
 (aListBox selectedItem) = '   '
      ifTrue: [ User enterPassword.].
 (aListBox selectedItem) = '  '
      ifTrue: [ Comp linking.].
 (aListBox selectedItem) = ' '
      ifTrue: [ Prov findPassword.].
 (aListBox selectedItem) = '   '
      ifTrue: [ Prov detectMoney.].
 (aListBox selectedItem) = '   Internet'
      ifTrue: [ Prov takeAccess.].
 (aListBox selectedItem) = ''
      ifTrue: [ User connect.].
 ].!
   
punkts
" .    "
^#('' ' ' '   ' '  ' ' '
    '   ' '   Internet' '' '')!
   
quit
" .   ,   "
 self close!

rollBack
NotAssign:=true.!
 
run
" "
 NotAssign:=true.
 self createViews.
 self answer:''.
 self work.!
   
toPlay:aPane
" .        "
aPane contents:'      "".
    Internet   "".
 '.!
  
work
" -        ''     "
 self initialState! !

Object subclass: #ProvClass
  instanceVariableNames: ''
  classVariableNames: 
    'Pass2 M1 Log3 Found M3 Pass1 Identify MD Price Pass3 M2 Log1 Log2 '
  poolDictionaries: ''    !


!ProvClass class methods ! !



!ProvClass methods !
 
detectMoney

 (Comp powerOn)
  ifTrue:[  (Pass enter)
                     ifTrue: [ (self found)
                                       ifTrue:[Internet answer:'    ', A money asString,' $.'. self md:true.]
                                       ifFalse:[ (Comp link) ifTrue: [(self identify) ifTrue: [ Internet answer: '    .    .'.]
                                                                                                           ifFalse:[ Internet answer: '         .'.]
                                                                                   ]
                                                                          ifFalse:[Internet answer:'    .'.]].
                                 ]
                    ifFalse: [Internet answer: '    .'.].
            ]
  ifFalse:[Internet answer: '  .'.].!
   
findPassword

 (Comp powerOn)
     ifTrue:[ (Pass enter)
                       ifTrue:[ (Comp link)
                                         ifTrue: [ self found: true.  self identify: true.
                                                       (Pass password = Pass1 and: [Pass login = Log1])
                                                                 ifTrue:[A money: M1 ]
                                                                 ifFalse:[ (Pass password = Pass2 and: [Pass login = Log2])
                                                                                   ifTrue:[A money: M2 ]
                                                                                   ifFalse:[ (Pass password = Pass3 and: [Pass login = Log3])
                                                                                                    ifTrue:[A money: M3 ]
                                                                                                    ifFalse:[self found: false]
                                                                                                ]
                                                                              ].
                                                         (self found) ifTrue: [Internet answer: '  .']
                                                                            ifFalse:[Internet answer: '    .    .'.]
                                                     ]
                                         ifFalse:[Internet answer:'    .'.].
                                     ]
                         ifFalse:[Internet answer:'    .'.].
                 ]
        ifFalse:[Internet answer:'  .'.].!
 
found
^Found.!
 
found: aBoolean
Found:= aBoolean.!
 
identify
^Identify.!
   
identify: aBoolean
Identify:= aBoolean.!
   
initialState
self found: false.
self identify: false.
 M1:=100.
 M2:=10.
 M3:=5.
 MD:=false.!
 
md
^MD!

md: aBoolean
MD:=aBoolean!
 
newGame

 Internet initialState.
 Pass1:=(Prompter prompt: '      .' default: '').
 Log1:=(Prompter prompt: '      .' default: '').
 Pass2:=(Prompter prompt: '      .' default: '').
 Log2:=(Prompter prompt: '      .' default: '').
 Pass3:=(Prompter prompt: '      .' default: '').
 Log3:=(Prompter prompt: '      .' default: '').
 self price: (Prompter prompt: '    Internet.' defaultExpression: '').

 (Pass1='' or:[ Pass2='' or:[ Pass3='' or:[Log1='' or: [Log2='' or: [Log3='']]]]])
 ifFalse: [
 Internet answer:' :'.
 Internet answer:'( /  /   )'.
 Internet answer:' 1. ', Pass1 asString, ' / ', Log1 asString, ' /  ', M1 asString,'$'.
 Internet answer:' 2. ', Pass2 asString, ' / ', Log2 asString, ' /  ', M2 asString,'$'.
 Internet answer:' 3. ', Pass3 asString, ' / ', Log3 asString, ' /  ', M3 asString,'$'.
 Internet answer:'    Internet: ', self price asString,'$'.
  ]
 ifTrue:[Internet answer: ':       .'
            Internet rollBack].!
   
price
^Price.!
 
price: aInteger
Price:= aInteger.!
 
takeAccess
 (Comp powerOn)
   ifTrue:[
   (Pass enter) ifTrue: [
   (Comp link)  ifTrue:[
   (self found)
      ifTrue: [ (self md)
                    ifTrue:[
                    (self price > A money)
                          ifTrue:[ Internet answer:'    .   .'.]
                          ifFalse:[ A money: A money - self price.
                                        (Pass password=Pass1)
                                                     ifTrue:[M1:=M1-self price]
                                                     ifFalse:[(Pass password=Pass2)
                                                                            ifTrue:[M2:=M2-self price]
                                                                            ifFalse:[M3:=M3-self price]
                                                                  ].
                                        User ent: true.
                                        Internet answer:'    ', self price asString,' $.';
                                                     answer:'    Internet.'].]
                       ifFalse:[ Internet answer: '     .']
                 ]
      ifFalse:[(self identify) ifTrue:[ Internet answer: '    .    .']
                                         ifFalse:[ Internet answer: '         .'] ].
             ] ifFalse:[Internet answer:'    .'.]]
               ifFalse:[Internet answer: '    .'] ]
               ifFalse:[Internet answer: '  .'].! !

Object subclass: #PasswordClass
  instanceVariableNames: ''
  classVariableNames: 
    'Password Login PassEnter '
  poolDictionaries: '' !


!PasswordClass class methods ! !



!PasswordClass methods !
 
enter
 ^PassEnter.!

enter: aBoolean
 PassEnter:= aBoolean.!

enterPass

   (Comp powerOn)
      ifTrue: [
                      Password:=(Prompter prompt: ' ' default: '').
                      Login:=(Prompter prompt:' ' default: '').
                     (Password = '' or: [Login = ''])
                             ifFalse:[self enter: true.]
                             ifTrue: [Internet answer: ':       .'].
                  ]
     ifFalse: [Internet answer:'  .'.].!
  
initialState
self enter: false.
self login: ''.
self password: ''.!
  
login
^Login.!
 
login: aString
Login:=aString.!

password
^Password.!
   
password: aString
Password:=aString.! !

Object subclass: #UserClass
  instanceVariableNames: ''
  classVariableNames: 
    'Ent '
  poolDictionaries: ''  !


!UserClass class methods ! !



!UserClass methods !
 
compPowerOn
 (Comp powerOn)
    ifFalse: [ Comp powerOn: true. Internet answer: '  .'. ]
    ifTrue: [ Internet answer: '  .'. ].!

connect
Internet answer:''.
Internet answer:'   :'.
(Comp powerOn)
   ifFalse:[self compPowerOn.].

(Comp powerOn)
    ifTrue:[(Pass enter) ifFalse:[self enterPassword.  Internet answer:' : ', Pass password asString,'  : ',Pass login asString,'.'.]].

(Comp powerOn and: [Pass enter])
    ifTrue:[(Comp link) ifFalse:[Comp linking. ]].

(Comp powerOn and: [Pass enter and: [Comp link]])
    ifTrue:[ (Prov identify) ifFalse: [Prov findPassword. ]].

(Comp powerOn and: [Pass enter and: [Comp link and:[Prov found]]])
    ifTrue:[(Prov md) ifFalse:[Prov detectMoney.]].

(Comp powerOn and: [Pass enter and: [Comp link and:[Prov found and:[ Prov md]]]])
    ifTrue:[  Prov takeAccess.].!
 
ent
^Ent.!
 
ent: aBoolean
Ent:=aBoolean.!
  
enterPassword
 (Comp powerOn)
     ifFalse:[  Internet answer: '  .'. ]
     ifTrue:[ Pass enterPass. Prov identify: false. Prov found: false. Prov md:false.].!
   
initialState
self ent: false.! !
